//
//  GBAppPrefsData.h
//  gBrowser
//
//  Created by Andreas Schwarz on Mon Dec 24 2001.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GBPrefsData.h"

@class GBFileItem;

@interface GBAppPrefsData : GBPrefsData {
    GBFileItem *defaultFile;
    BOOL openUntitledAuto;
    BOOL checkForUpdatesOnStartup;
    BOOL registered;
	BOOL launchedBefore;
    BOOL loadAsync;
    BOOL checkCrashLogs;
    BOOL sendCrashLogsInBackground;
    BOOL openBrowserOnImageDrop;
    NSDate *installDate;
    NSDate *lastRegisterNoticeDate;
    NSDate *lastCrashLogCheckDate;
    
    // Hotkeys
    NSDictionary *zoomInHotKey;
    NSDictionary *zoomOutHotKey;
    NSDictionary *rotateClockwiseHotKey;
    NSDictionary *rotateCounterclockwiseHotKey;
    NSDictionary *recenterHotKey;
    NSDictionary *fitToWindowHotKey;
    NSDictionary *fitToScreenHotKey;
    NSDictionary *scaleTo100HotKey;
    NSDictionary *moveLeftHotKey;
    NSDictionary *moveRightHotKey;
    NSDictionary *moveUpHotKey;
    NSDictionary *moveDownHotKey;
    NSDictionary *moveUpLeftHotKey;
    NSDictionary *moveUpRightHotKey;
    NSDictionary *moveDownLeftHotKey;
    NSDictionary *moveDownRightHotKey;
	
	// Menu hotkeys
	NSMutableDictionary *hotkeysDictionary;
}

- (id)initWithUndoManager:(NSUndoManager *)um;

- (void)setOpenUntitledAuto:(BOOL)value;
- (BOOL)openUntitledAuto;

- (BOOL)setDefaultFileItem:(GBFileItem *)file;
- (GBFileItem *)defaultFileItem;

- (NSString *)defaultFileName;

- (BOOL)loadAsynchronously;
- (void)setLoadAsynchronously:(BOOL)async;


@property(retain) NSDate *lastCrashLogCheckDate;
@property(assign) BOOL checkCrashLogs;
@property(assign) BOOL sendCrashLogsInBackground;


- (void)setHotkey:(NSDictionary *)hotkey forKey:(NSString *)key;
- (NSDictionary *)getHotkeyForKey:(NSString *)key;

- (BOOL)checkForUpdatesOnStartup;
- (void)setCheckForUpdatesOnStartup:(BOOL)ch;

- (BOOL)openBrowserOnImageDrop;
- (void)setOpenBrowserOnImageDrop:(BOOL)open;

- (BOOL)launchedBefore;
- (void)setLaunchedBefore:(BOOL)first;
- (BOOL)isRegistered;
- (void)setRegistered:(BOOL)reg;

- (void)setInstallDate:(NSDate *)date;
- (NSDate *)installDate;
- (void)setLastRegisterNoticeDate:(NSDate *)date;
- (NSDate *)lastRegisterNoticeDate;


@end

extern NSString *GBDefaultFilePathChangedNotification;
extern NSString *GBOpenUntitledAutoChangedNotification;
extern NSString *GBCheckForUpdatesOnStartupChangedNotification;
extern NSString *GBOpenBrowserOnImageDropChangedNotification;

extern NSString *GBLoadAsyncChangedNotification;

extern NSString *GBMenuHotkeyChangedNotification;




